{Modified from
''
''  DS2760 Driver Ver. 00.1
''
''  Timothy D. Swieter, E.I.
''  www.brilldea.com
and the table data is from Parallax

}


pub findTCtempK(_cjcomp) : tct

   ' Modified Lookup routine
     Repeat while _cjComp < kTable[tct]
      ' Repeat until we step over the value. 
      tct := tct + 100
     ' Go back one step
     tct := tct - 100
     repeat while _cjComp < kTable[tct] 
       'Make Smaller Steps until we go over the maxium again. 
       tct:= tct+10
     'Go back one 10 step
     tct := tct-10

     'Now move up 1 at a time until we find it. 
     repeat while _CjComp < kTable[tct]
      tct++

     ' Value is returned here. 
     tct--

Pub findTCtempTypeK(_cjcomp) : tct | t0, lowt, hight
'***************************************
''Look into the data table and return the C for the compensated thermocouple millivolt value
''
  'preset tct for an error condition
  tct := -1


  'First narrow down where in the table the temperature is, this is suppose to
  'make the search a little faster than looping through every number
  case _cjcomp
    Ktable[0]..Ktable[99] : lowt := 0
                            hight := 99
                          
    Ktable[100]..Ktable[199] : lowt := 100
                               hight := 199
                             
    Ktable[200]..Ktable[299] : lowt := 200
                               hight := 299

    '                          
    Ktable[300]..Ktable[399] : lowt := 300
                               hight := 399

    Ktable[400]..Ktable[499] : lowt := 400
                               hight := 499

    Ktable[500]..Ktable[599] : lowt := 500
                               hight := 599                                                          

    Ktable[600]..Ktable[699] : lowt := 600
                               hight := 699

    Ktable[700]..Ktable[779] : lowt := 700
                               hight := 799

    Ktable[800]..Ktable[899] : lowt := 800
                               hight := 899

    Ktable[900]..Ktable[999] : lowt := 900
                               hight := 999

    Ktable[1000]..Ktable[1020] : lowt := 1000
                               hight := 1020                               

  'Using the narrowed search from above, low through each entry to determine
  'the value we are searching for
  repeat t0 from lowt to hight
    if _cjcomp < Ttable[t0]
      tct := t0 - 1
      return tct


Dat
' A tempature lookup table for K type thermocouples. 
' tC                  +0,    +1,    +2,    +3,    +4,    +5     +6,    +7,    +8,    +9               
Ktable        Word 00000, 00039, 00079, 00119, 00158, 00198, 00238, 00277, 00317, 00357  '   0C
              Word 00397, 00437, 00477, 00517, 00557, 00597, 00637, 00677, 00718, 00758  '  10C
              Word 00798, 00838, 00879, 00919, 00960, 01000, 01040, 01080, 01122, 01163  '  20C
              Word 01203, 01244, 01284, 01326, 01366, 01407, 01448, 01489, 01530, 01570  '  30C
              Word 01612, 01653, 01694, 01735, 01776, 01816, 01858, 01899, 01941, 01982  '  40C
              Word 02023, 02064, 02105, 02146, 02188, 02230, 02270, 02311, 02354, 02395  '  50C
              Word 02436, 02478, 02519, 02560, 02601, 02644, 02685, 02726, 02767, 02810  '  60C
              Word 02850, 02892, 02934, 02976, 03016, 03059, 03100, 03141, 03184, 03225  '  70C
              Word 03266, 03307, 03350, 03391, 03432, 03474, 03516, 03557, 03599, 03640  '  80C
              Word 03681, 03722, 03765, 03806, 03847, 03888, 03931, 03972, 04012, 04054  '  90C
              Word 04096, 04137, 04179, 04219, 04261, 04303, 04344, 04384, 04426, 04468  ' 100C
              Word 04509, 04549, 04591, 04633, 04674, 04714, 04756, 04796, 04838, 04878  ' 110C
              Word 04919, 04961, 05001, 05043, 05083, 05123, 05165, 05206, 05246, 05288  ' 120C
              Word 05328, 05368, 05410, 05450, 05490, 05532, 05572, 05613, 05652, 05693  ' 130C
              Word 05735, 05775, 05815, 05865, 05895, 05937, 05977, 06017, 06057, 06097  ' 140C
              Word 06137, 06179, 06219, 06259, 06299, 06339, 06379, 06419, 06459, 06500  ' 150C
              Word 06540, 06580, 06620, 06660, 06700, 06740, 06780, 06820, 06860, 06900  ' 160C
              Word 06940, 06980, 07020, 07059, 07099, 07139, 07179, 07219, 07259, 07299  ' 170C
              Word 07339, 07379, 07420, 07459, 07500, 07540, 07578, 07618, 07658, 07698  ' 180C
              Word 07738, 07778, 07819, 07859, 07899, 07939, 07979, 08019, 08058, 08099  ' 190C
              Word 08137, 08178, 08217, 08257, 08298, 08337, 08378, 08417, 08458, 08499  ' 200C
              Word 08538, 08579, 08618, 08659, 08698, 08739, 08778, 08819, 08859, 08900  ' 210C
              Word 08939, 08980, 09019, 09060, 09101, 09141, 09180, 09221, 09262, 09301  ' 220C
              Word 09343, 09382, 09423, 09464, 09503, 09544, 09585, 09625, 09666, 09707  ' 230C
              Word 09746, 09788, 09827, 09868, 09909, 09949, 09990, 10031, 10071, 10112  ' 240C
              Word 10153, 10194, 10234, 10275, 10316, 10356, 10397, 10439, 10480, 10519  ' 250C
              Word 10560, 10602, 10643, 10683, 10724, 10766, 10807, 10848, 10888, 10929  ' 260C
              Word 10971, 11012, 11053, 11093, 11134, 11176, 11217, 11259, 11300, 11340  ' 270C
              Word 11381, 11423, 11464, 11506, 11547, 11587, 11630, 11670, 11711, 11753  ' 280C
              Word 11794, 11836, 11877, 11919, 11960, 12001, 12043, 12084, 12126, 12167  ' 290C
              Word 12208, 12250, 12291, 12333, 12374, 12416, 12457, 12499, 12539, 12582  ' 300C
              Word 12624, 12664, 12707, 12747, 12789, 12830, 12872, 12914, 12955, 12997  ' 310C
              Word 13039, 13060, 13122, 13164, 13205, 13247, 13289, 13330, 13372, 13414  ' 320C
              Word 13457, 13497, 13539, 13582, 13624, 13664, 13707, 13749, 13791, 13833  ' 330C
              Word 13874, 13916, 13958, 14000, 14041, 14083, 14125, 14166, 14208, 14250  ' 340C
              Word 14292, 14335, 14377, 14419, 14461, 14503, 14545, 14586, 14628, 14670  ' 350C
              Word 14712, 14755, 14797, 14839, 14881, 14923, 14964, 15006, 15048, 15090  ' 360C
              Word 15132, 15175, 15217, 15259, 15301, 15343, 15384, 15426, 15468, 15510  ' 370C
              Word 15554, 15596, 15637, 15679, 15721, 15763, 15805, 15849, 15891, 15932  ' 380C
              Word 15974, 16016, 16059, 16102, 16143, 16185, 16228, 16269, 16312, 16355  ' 390C
              Word 16396, 16439, 16481, 16524, 16565, 16608, 16650, 16693, 16734, 16777  ' 400C
              Word 16820, 16861, 16903, 16946, 16989, 17030, 17074, 17115, 17158, 17201  ' 410C
              Word 17242, 17285, 17327, 17370, 17413, 17454, 17496, 17539, 17582, 17623  ' 420C
              Word 17667, 17708, 17751, 17794, 17836, 17879, 17920, 17963, 18006, 18048  ' 430C
              Word 18091, 18134, 18176, 18217, 18260, 18303, 18346, 18388, 18431, 18472  ' 440C
              Word 18515, 18557, 18600, 18643, 18686, 18728, 18771, 18812, 18856, 18897  ' 450C
              Word 18940, 18983, 19025, 19068, 19111, 19153, 19196, 19239, 19280, 19324  ' 460C
              Word 19365, 19408, 19451, 19493, 19536, 19579, 19621, 19664, 19707, 19750  ' 470C
              Word 19792, 19835, 19876, 19920, 19961, 20004, 20047, 20089, 20132, 20175  ' 480C
              Word 20218, 20260, 20303, 20346, 20388, 20431, 20474, 20515, 20559, 20602  ' 490C
              Word 20643, 20687, 20730, 20771, 20815, 20856, 20899, 20943, 20984, 21027  ' 500C
              Word 21071, 21112, 21155, 21199, 21240, 21283, 21326, 21368, 21411, 21454  ' 510C
              Word 21497, 21540, 21582, 21625, 21668, 21710, 21753, 21795, 21838, 21881  ' 520C
              Word 21923, 21966, 22009, 22051, 22094, 22137, 22178, 22222, 22265, 22306  ' 530C
              Word 22350, 22393, 22434, 22478, 22521, 22562, 22606, 22649, 22690, 22734  ' 540C
              Word 22775, 22818, 22861, 22903, 22946, 22989, 23032, 23074, 23117, 23160  ' 550C
              Word 23202, 23245, 23288, 23330, 23373, 23416, 23457, 23501, 23544, 23585  ' 560C
              Word 23629, 23670, 23713, 23757, 23798, 23841, 23884, 23926, 23969, 24012  ' 570C
              Word 24054, 24097, 24140, 24181, 24225, 24266, 24309, 24353, 24394, 24437  ' 580C
              Word 24480, 24523, 24565, 24608, 24650, 24693, 24735, 24777, 24820, 24863  ' 590C
              Word 24905, 24948, 24990, 25033, 25075, 25118, 25160, 25203, 25245, 25288  ' 600C
              Word 25329, 25373, 25414, 25457, 25500, 25542, 25585, 25626, 25670, 25711  ' 610C
              Word 25755, 25797, 25840, 25882, 25924, 25967, 26009, 26052, 26094, 26136  ' 620C
              Word 26178, 26221, 26263, 26306, 26347, 26390, 26432, 26475, 26516, 26559  ' 630C
              Word 26602, 26643, 26687, 26728, 26771, 26814, 26856, 26897, 26940, 26983  ' 640C
              Word 27024, 27067, 27109, 27152, 27193, 27236, 27277, 27320, 27362, 27405  ' 650C
              Word 27447, 27489, 27531, 27574, 27616, 27658, 27700, 27742, 27784, 27826  ' 660C
              Word 27868, 27911, 27952, 27995, 28036, 28079, 28120, 28163, 28204, 28246  ' 670C
              Word 28289, 28332, 28373, 28416, 28416, 28457, 28500, 28583, 28626, 28667  ' 680C
              Word 28710, 28752, 28794, 28835, 28877, 28919, 28961, 29003, 29045, 29087  ' 690C
              Word 29129, 29170, 29213, 29254, 29297, 29338, 29379, 29422, 29463, 29506  ' 700C
              Word 29548, 29589, 29631, 29673, 29715, 29757, 29798, 29840, 29882, 29923  ' 710C
              Word 29964, 30007, 30048, 30089, 30132, 30173, 30214, 30257, 30298, 30341  ' 720C
              Word 30382, 30423, 30466, 30507, 30548, 30589, 30632, 30673, 30714, 30757  ' 730C
              Word 30797, 30839, 30881, 30922, 30963, 31006, 31047, 31088, 31129, 31172  ' 740C
              Word 31213, 31254, 31295, 31338, 31379, 31420, 31461, 31504, 31545, 31585  ' 750C
              Word 31628, 31669, 31710, 31751, 31792, 31833, 31876, 31917, 31957, 32000  ' 760C
              Word 32040, 32082, 32124, 32164, 32206, 32246, 32289, 32329, 32371, 32411  ' 770C
              Word 32453, 32495, 32536, 32577, 32618, 32659, 32700, 32742, 32783, 32824  ' 780C
              Word 32865, 32905, 32947, 32987, 33029, 33070, 33110, 33152, 33192, 33234  ' 790C
              Word 33274, 33316, 33356, 33398, 33439, 33479, 33521, 33561, 33603, 33643  ' 800C
              Word 33685, 33725, 33767, 33807, 33847, 33889, 33929, 33970, 34012, 34052  ' 810C
              Word 34093, 34134, 34174, 34216, 34256, 34296, 34338, 34378, 34420, 34460  ' 820C
              Word 34500, 34542, 34582, 34622, 34664, 34704, 34744, 34786, 34826, 34866  ' 830C
              Word 34908, 34948, 34999, 35029, 35070, 35109, 35151, 35192, 35231, 35273  ' 840C
              Word 35313, 35353, 35393, 35435, 35475, 35515, 35555, 35595, 35637, 35676  ' 850C
              Word 35718, 35758, 35798, 35839, 35879, 35920, 35960, 36000, 36041, 36081  ' 860C
              Word 36121, 36162, 36202, 36242, 36282, 36323, 36363, 36403, 36443, 36484  ' 870C
              Word 36524, 36564, 36603, 36643, 36685, 36725, 36765, 36804, 36844, 36886  ' 880C
              Word 36924, 36965, 37006, 37045, 37085, 37125, 37165, 37206, 37246, 37286  ' 890C
              Word 37326, 37366, 37406, 37446, 37486, 37526, 37566, 37606, 37646, 37686  ' 900C
              Word 37725, 37765, 37805, 37845, 37885, 37925, 37965, 38005, 38044, 38084  ' 910C
              Word 38124, 38164, 38204, 38243, 38283, 38323, 38363, 38402, 38442, 38482  ' 920C
              Word 38521, 38561, 38600, 38640, 38679, 38719, 38759, 38798, 38838, 38878  ' 930C
              Word 38917, 38957, 38996, 39036, 39076, 39115, 39164, 39195, 39234, 39274  ' 940C
              Word 39314, 39353, 39393, 39432, 39470, 39511, 39549, 39590, 39628, 39668  ' 950C'
              Word 39707, 39746, 39786, 39826, 39865, 39905, 39944, 39984, 40023, 40061  ' 960C
              Word 40100, 40140, 40179, 40219, 40259, 40298, 40337, 40375, 40414, 40454  ' 970C
              Word 40493, 40533, 40572, 40610, 40651, 40689, 40728, 40765, 40807, 40846  ' 980C
              Word 40885, 40924, 40963, 41002, 41042, 41081, 41119, 41158, 41198, 41237  ' 990C
              Word 41276, 41315, 41354, 41393, 41431, 41470, 41509, 41548, 41587, 41626  '1000C
              Word 41665, 41704, 41743, 41781, 41820, 41859, 41898, 41937, 41976, 42014  '1100C
              Word 42053, 42092, 42131, 42169                                            '1020C      